AWSTemplateFormatVersion: '2010-09-09'
Transform: AWS::Serverless-2016-10-31
Description: web api for vsm radar demo

Globals:
  Function:
    Runtime: nodejs6.10
    Timeout: 30
Parameters:
  Stage:
    Type: String
    Default: dev
Resources:
  lambdaIamRole:
    Type: AWS::IAM::Role
    Properties:
      AssumeRolePolicyDocument:
        Version: "2012-10-17"
        Statement:
          - Effect: Allow
            Principal:
              Service: lambda.amazonaws.com
            Action: "sts:AssumeRole"
      Policies:
        -
          PolicyName: "cloudwatch_and_dynamodb_for_lambda"
          PolicyDocument:
            Version: "2012-10-17"
            Statement:
              -
                Effect: "Allow"
                Action: "cloudwatch:*"
                Resource: "*"
              -
                Effect: "Allow"
                Action: "dynamodb:*"
                Resource: "*"
  lambdaGet:
    Type: AWS::Serverless::Function
    Properties:
      Handler: vsmRadarApi-get.handler
      Runtime: nodejs6.10
      Timeout: 30
      Role: !GetAtt lambdaIamRole.Arn
      Events:
        Registration:
          Type: Api
          Properties:
            Path: /get
            RestApiId: !Ref vsmApi
            Method: get
  lambdaAdd:
    Type: AWS::Serverless::Function
    Properties:
      Handler: vsmRadarApi-add.handler
      Runtime: nodejs6.10
      Timeout: 30
      Role: !GetAtt lambdaIamRole.Arn
      Events:
        Registration:
          Type: Api
          Properties:
            Path: /add
            RestApiId: !Ref vsmApi
            Method: post
  vsmApi:
    Type: AWS::Serverless::Api
    Properties:
      StageName: !Ref Stage
      DefinitionBody:
        swagger: "2.0"
        info:
          title:
            Fn::Sub: swagger-transform-1-${Stage}
          description:
            Fn::Sub: swagger-transform-1-${Stage}
          version: 1.0.0
        basePath:
          Fn::Sub: /${Stage}
        schemes:
          - "https"
        paths:
          /add:
            post:
              produces:
              - "application/json"
              responses:
                "200":
                  description: "200 response"
                  schema:
                    $ref: "#/definitions/Empty"
              x-amazon-apigateway-integration:
                uri:
                  Fn::Sub: "arn:aws:apigateway:ap-northeast-1:lambda:path/2015-03-31/functions/${lambdaAdd.Arn}/invocations"
                responses:
                  default:
                    statusCode: 200
                passthroughBehavior: "when_no_match"
                httpMethod: "POST"
                contentHandling: "CONVERT_TO_TEXT"
                type: "aws"
          /get:
            get:
              produces:
              - "application/json"
              parameters:
              - name: "from"
                in: "query"
                required: true
                type: "string"
              - name: "deviceId"
                in: "query"
                required: true
                type: "string"
              - name: "to"
                in: "query"
                required: true
                type: "string"
              responses:
                "200":
                  description: "200 response"
                  schema:
                    $ref: "#/definitions/Empty"
              x-amazon-apigateway-request-validator: "Validate body, query string parameters,\
                \ and headers"
              x-amazon-apigateway-integration:
                uri:
                  Fn::Sub: "arn:aws:apigateway:ap-northeast-1:lambda:path/2015-03-31/functions/${lambdaGet.Arn}/invocations"
                responses:
                  default:
                    statusCode: 200
                passthroughBehavior: "when_no_match"
                httpMethod: "POST"
                contentHandling: "CONVERT_TO_TEXT"
                type: "aws_proxy"
        definitions:
          Empty:
            type: "object"
            title: "Empty Schema"
        x-amazon-apigateway-request-validators:
          Validate body, query string parameters, and headers:
            validateRequestParameters: true
            validateRequestBody: true
  vsmRadarTable:
    Type: AWS::DynamoDB::Table
    Properties:
      TableName: vsmRadarTable
      AttributeDefinitions:
        - AttributeName: deviceId
          AttributeType: N
        - AttributeName: datetime
          AttributeType: N
      KeySchema:
        - AttributeName: deviceId
          KeyType: HASH
        - AttributeName: datetime
          KeyType: RANGE
      ProvisionedThroughput:
        ReadCapacityUnits: 5
        WriteCapacityUnits: 5
